%define module_name iwlwifi
%define iwlwifi_version 1.2.25
%define mac80211_version 10.0.4
%define module_path %{_usrsrc}/iwlwifi-%{iwlwifi_version}-%{release}


Summary:	Updated version of iwlwifi driver
Name:		dkms-%{module_name}
Version:	%{iwlwifi_version}
Release:	%mkrel 7
License:	GPL
Group:		System/Kernel and hardware
URL:		http://intellinuxwireless.org/?p=iwlwifi
Source0:	http://intellinuxwireless.org/iwlwifi/downloads/iwlwifi-%{iwlwifi_version}.tgz
Source1:	http://intellinuxwireless.org/iwlwifi/downloads/mac80211-%{mac80211_version}.tgz
Source2:	iwlwifi-build.sh
Patch0:		mac80211-10.0.3-2.6.24.patch
# Based on 7f3ad8943e2e6336ba229b208be8c7a80730c5d
Patch1:		mac80211-10.0.4-decrypt-failed-messages.patch
Requires(preun):	dkms
Requires(post):	dkms
Requires(post):	rsync
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description
The iwlwifi project provides a driver which utilizes the new mac80211
subsystem for the Intel Wireless WiFi Link 4965AGN and
Intel PRO/Wireless 3945ABG Network Connection adapters.

This package contains an updated version of mac80211 and iwlwifi.

%prep

%setup -q -n iwlwifi-%{version} -a0 -a1
cd mac80211-%{mac80211_version}
%patch0 -p1
%patch1 -p0

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{module_path}

cp -a iwlwifi-* mac80211-* %{SOURCE2} %{buildroot}/%{module_path}
chmod +x %{buildroot}/%{module_path}/*.sh

cat > %{buildroot}/%{module_path}/dkms.conf <<EOF
PACKAGE_VERSION="%{version}-%{release}"

# Items below here should not have to change with each driver version
PACKAGE_NAME="%{module_name}"
MAKE[0]="KSRC=\${kernel_source_dir} ./iwlwifi-build.sh && make -C \${kernel_source_dir} SUBDIRS=\${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build modules"
CLEAN="rm -rf iwlwifi mac80211 Makefile.*"
BUILT_MODULE_LOCATION[0]="iwlwifi/compatible/"
BUILT_MODULE_NAME[0]="iwl3945"
DEST_MODULE_LOCATION[0]="/kernel/drivers/net/wireless/%{module_name}"
BUILT_MODULE_LOCATION[1]="iwlwifi/compatible/"
BUILT_MODULE_NAME[1]="iwl4965"
DEST_MODULE_LOCATION[1]="/kernel/drivers/net/wireless/%{module_name}"
BUILT_MODULE_LOCATION[2]="mac80211/compatible/net/mac80211/"
BUILT_MODULE_NAME[2]="iwlwifi_mac80211"
DEST_MODULE_LOCATION[2]="/kernel/drivers/net/wireless/%{module_name}"
BUILT_MODULE_LOCATION[3]="mac80211/compatible/net/mac80211/"
BUILT_MODULE_NAME[3]="iwlwifi_rc80211_simple"
DEST_MODULE_LOCATION[3]="/kernel/drivers/net/wireless/%{module_name}"
REMAKE_INITRD="no"
AUTOINSTALL="yes"
EOF

%clean
rm -rf %{buildroot}

%post
dkms add     -m %{module_name} -v %{version}-%{release} --rpm_safe_upgrade
dkms build   -m %{module_name} -v %{version}-%{release} --rpm_safe_upgrade
dkms install -m %{module_name} -v %{version}-%{release} --rpm_safe_upgrade
# rmmod any old driver if present and not in use
rmmod %{module_name} > /dev/null 2>&1 || true

%preun
dkms remove  -m %{module_name} -v %{version}-%{release} --all --rpm_safe_upgrade

%files
%defattr(-,root,root)
%doc iwlwifi-1.2.25/{LICENSE*,README.iwlwifi,ISSUES,CHANGES}
%{module_path}


%changelog
* Thu Jul 24 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.2.25-7mdv2009.0
+ Revision: 244347
- rebuild

* Fri Apr 04 2008 Pascal Terjan <pterjan@mandriva.org> 1.2.25-5mdv2008.1
+ Revision: 192307
- Fix dkms.conf to build on non current kernel

* Thu Apr 03 2008 Pascal Terjan <pterjan@mandriva.org> 1.2.25-4mdv2008.1
+ Revision: 192290
- Fix requires

* Thu Mar 13 2008 Pascal Terjan <pterjan@mandriva.org> 1.2.25-3mdv2008.1
+ Revision: 187420
- Disable messages about decryption failed, it can be normal
- Don't modify the origin, else copying is useless

* Thu Mar 13 2008 Pascal Terjan <pterjan@mandriva.org> 1.2.25-2mdv2008.1
+ Revision: 187289
- Fail early if the correct kernel-devel is not installed
- Update mac80211 to 10.0.4

* Wed Mar 12 2008 Pascal Terjan <pterjan@mandriva.org> 1.2.25-1mdv2008.1
+ Revision: 186999
- import dkms-iwlwifi


